
<p align="center">
  <img src="netmaker.png"><break/>
</p>
<p align="center">
<i>Connect any computers together over a secure, fast, private network, and manage multiple networks from a central server.</i> 
</p>

## Documentation

### Netmaker's documentation can be found at:  
###  [docs.netmaker.org](https://docs.netmaker.org)
###  [netmaker.readthedocs.io](https://netmaker.readthedocs.io)
  
For information about installing and using Netmaker, including the [quick start guide](https://docs.netmaker.org/quick-start.html), please visit one of the above documentation sites, or read on for a short description of Netmaker.

## What is Netmaker?
Netmaker is a platform for creating and managing networks that are:

- Fast
- Secure
- Dynamic
- Virtual
- Zero-Trust
- WireGuard-based

Netmaker manages networks between computers that span data centers, clouds, and edge devices. Networking between environments can be a challenge, so Netmaker is designed to allow developers, DevOps engineers, SRE's, and others to manage virtual networks with as little pain as possible. You create a network with a few clicks, and add machines to that network with a single command.

## Why Netmaker?
 1. Create a flat, secure network between multiple/hybrid cloud environments
 2. Integrate central and edge services
 3. Secure a home or office network while providing remote connectivity
 4. Provide an additional layer of security on an existing network
 5. Encrypt Kubernetes inter-node communications
 6. Secure site-to-site connections
 7. Connect to IoT devices
 8. Manage an existing WireGuard setup with less manual configuration

<p align="center">
  <img src="mesh-diagram.png">
</p>


#### LICENSE

Netmaker's source code and all artifacts in this repository are freely available. All versions are published under the Server Side Public License (SSPL), version 1, which can be found here: [LICENSE.txt](./LICENSE.txt).

#### CONTACT

Email: info@gravitl.com  
Discord: https://discord.gg/zRb9Vfhk8A
